import 'dart:math' as math;

import 'package:flutter/material.dart';
import 'package:my_app2/Network/api/product_api.dart';
import 'package:my_app2/Network/http/BaseApi.dart';

class Customization extends StatefulWidget {
  const Customization({super.key});

  State<Customization> createState() => _CustomizationState();
}

class _CustomizationState extends State<Customization> {
  @override
  void initState() {
    super.initState();
    ProductListApi request = ProductListApi(page: 1, pageSize: 10);
    request.request(onSuccessed: (value) {
      print(value);
    }, onFailed: (error) {
      print(error.toString());
    });
  }

  @override
  Widget build(BuildContext context) {
    List<String> dataSource = [
      "https://static.preclight.com/uploads/2023-02-08/63e36bec6e8f4.png",
      "https://static.preclight.com/uploads/2023-02-20/63f2e9568b736.jpg",
      "https://static.preclight.com/uploads/2023-02-07/63e219498801e.jpg",
      "https://static.preclight.com/uploads/2023-02-07/63e2123ea9287.jpg",
      "https://static.preclight.com/uploads/2023-02-07/63e21685eb2b4.png",
      "https://static.preclight.com/uploads/2023-01-31/63d8f975dc915.jpg",
      "https://static.preclight.com/uploads/2023-01-31/63d8f4cde0315.jpg",
      "https://static.preclight.com/uploads/2023-02-22/63f59104a7fe7.png",
      "https://static.preclight.com/uploads/2023-01-19/63c8e4eb35d16.png",
      "https://static.preclight.com/uploads/2022-11-30/6387278fd8022.jpg"
    ];
    return Scaffold(
        appBar: AppBar(title: const Text('热门产品')),
        body: CustomScrollView(slivers: [
          SliverPadding(
            padding: const EdgeInsets.symmetric(horizontal: 12),
            sliver: SliverList(
                delegate: ProductSliverBuilderDelegate(dataSource, 10)),
          ),
          SliverList(
              delegate:
                  SliverChildBuilderDelegate((BuildContext context, int index) {
            return const SizedBox(
              height: 40,
              child: Text("hello world"),
            );
          }, childCount: 2))
        ]));
  }
}

class ProductSliverBuilderDelegate extends SliverChildBuilderDelegate {
  static int _computeActualChildCount(int itemCount) {
    return math.max(0, itemCount * 2 - 1);
  }

  final List<String> dataSource;
  final double spacing;
  ProductSliverBuilderDelegate(this.dataSource, this.spacing)
      : assert(spacing > 0),
        super((context, index) {
          final int itemIndex = index ~/ 2;
          final Widget? widget;
          if (index.isEven) {
            double height = MediaQuery.of(context).size.width - 12.0 * 2;
            String imgUrl = dataSource[itemIndex];
            widget = Container(
              decoration: const BoxDecoration(
                  borderRadius: BorderRadius.all(Radius.circular(12.0))),
              clipBehavior: Clip.antiAlias,
              height: height,
              child: Stack(
                fit: StackFit.expand,
                children: [Image.network(imgUrl)],
              ),
            );
          } else {
            widget = Divider(
              height: spacing,
              color: Colors.transparent,
            );
          }
          return widget;
        }, childCount: _computeActualChildCount(dataSource.length));
}
